Subject: RE: [imss] WG last call review: T11-FC-ZONE-SERVER-MIB in

From: "Wijnen, Bert (Bert)" <[email-masked]>
Date: Tue, 12 Sep 2006 15:40:00 +0200

Inline

> -----Original Message-----
> From: Keith McCloghrie [mailto:[email-masked]]
> Sent: Monday, September 11, 2006 22:34
> To: [email-masked]
> Cc: [email-masked]; [email-masked]; [email-masked]
> Subject: Re: [imss] WG last call review: T11-FC-ZONE-SERVER-MIB in
> 
> 
> Thanks for the comments.  Responses below.
> 
> Keith.
> ---------------------------
> 
> > T11-FC-ZONE-SERVER-MIB
> > 
> > --------- questions/comments
> > 
> > - Would it be better to rename T11ZoningName to T11ZsZoningName?
> >   This for naming consistency and avoiding possible future name
> >   clashes.
>  
> First, I would agree if its name was ZoningName, but prepended with
> "T11", the odds of it having any affect on "future name clashes" is
> negligible.
> 
Oh, if it did not start with T11, I would RECOMMEND to change it.
Now it is just a thought that I wanted you to consider.
If a name clash ever occurs, then it is 99.999% to happen in T11 space,
so the WG can decide.

> Second, I regret that I named T11NsGs4RejectReasonCode with an
> "Ns" in the middle -- it would have been better to have named it
> T11Gs4RejectReasonCode, or better still T11GsRejectReasonCode, 
> because it has been used in several FC MIBs for protocols defined in
> FC-GS-nn, i.e., it is not specific to the Name Server and not specific
> to FC-GS-4.
> 
> Third, if used in another MIB, the place where it is defined is
> specified in the IMPORTS clause, and thus, doesn't have to be explicit
> from the name.
> 
> Nevertheless, if you insist that I repeat my past mistakes:-), OK.
> 

I do not insist. I list what I see/perceive as things to consider and
that I prefer people take conscious decision on. If your (WG) decision
is to stick with what you have, I can live with it.

> > - For t11ZsServerDistribute
> >           Setting this object will fail if the corresponding
> >           instance of t11ZsServerOperationMode has the value
> >           'enhanced', or if the corresponding instance of
> >           t11ZsZoneSetResult has the value 'inProgress'."
> >   
> >   will fail with what? I assume/think 'inconsistentValue'.
> >   Might be good to state so, to ensure proper implementation.
> 
> I disagree.  I think it's bad practice to put error codes in
> DESCRIPTIONs. 

I agree if the errors are very obvious.
Unfortunately we have seen too many people who do not read the
sequence in RFC3416 very well and implement the wrong error
returncode. So that is why I bring it up.

> I just cricitized the IPSP WG MIBs for putting
> 'inconsistentValue' in their DESCRIPTIONs because that error code
> is NOT used if and when any of the nine higher-precedence error
> conditions prevails.
> 

Well, I agree that one has to explain in what circumstance the
inconsistentValue needs to be returned. Of course all goes accoring
to the steps listed in RFC3416

> How about I change it to:
> 
>          When the corresponding instance of t11ZsServerOperationMode
>          has the value 'enhanced', or when the corresponding instance
>          of t11ZsZoneSetResult has the value 'inProgress', it
>          is inconsistent to try to set the value of this object.
> 

That will do it for me.
Because I can determine from that when to return inconsistenValue ;-)

> > - Now that I see t11ZsServerReasonCode, I wonder if the 2nd
> >   para in the DESCRIPTION clause would also make sense for
> >   the t11FLockRejectReasonCode object
>  
> OK.
> 
thanks

> > - do the SIZE for t11ZsServerReasonCodeExp
> >   and t11ZsServerReasonVendorCode possibly also make sense for 
> >   t11FLockRejectReasonCodeExp, t11FLockRejectReasonVendorCode
> >   that is allowing for a SIZE of zero?
>   
> OK.
> 
thanks

> > - I wonder why this
> > 
> >     t11ZsServerDefaultZoneSetting OBJECT-TYPE
> >         SYNTAX       INTEGER {
> >                         permit(1),
> >                         deny(2)
> >                      }
> > 
> >   Is not done with a TruthValue possibly using a different descriptor.
> >   Not a fatal flaw though, but a missed opportunity for
> >   re-use in my view. Unless if one expects more values in
> >   the future.
> > 
> >   For t11ZsServerMergeControlSetting it is less obvious, but the
> >   same question could be asked I guess.
>  
> Each object in question refers to the setting of a single bit, which
> (obviously:-) takes the values 0 or 1, and so, yes, it would be possible
> to define each object as a TruthValue which has two values 'true' and
> 'false'.  However, the FC-GS-5 spec does not define either bit as:
> true/false.  Instead, it defines the behaviour when the bit is 0, and
> the behaviour when the bit is 1.  I think it's better in these cases to
> emphasize the commonality with FC-GS-5 by using the same definition,
> rather than intepreting the definitions as true/false.
> 

So it seems you are mapping a 1-bit value from the protocol to an object.
Makes sense. I guess if I had read the underlying protocol spec(s) better,
that I might have no asked the question. Hope you don't mind asking questions
as a new-reader of the MIB module.

> > - I see:
> >     t11ZsSetName OBJECT-TYPE
> >         SYNTAX       T11ZoningName
> >         MAX-ACCESS   read-create
> >         STATUS       current
> >         DESCRIPTION
> >            "The name of this Zone Set. The t11ZsSetName should
> >            be unique within a fabric.
> > 
> >            The Zone Set can be renamed by setting this object
> >            to a new value."
> > 
> >   and wonder if the rename can also be done while the row is in
> >   'active' state !!??
>  
> It can.  I'll add a few words.
> 
Thanks

> > - I am not sure I understand this:
> > 
> >     t11ZsSetEntry  OBJECT-TYPE
> >         SYNTAX       T11ZsSetEntry
> >         MAX-ACCESS   not-accessible
> >         STATUS       current
> >         DESCRIPTION
> >            "Each entry contains information about a Zone Set
> >            in the Zone Set database of a particular fabric
> >            (identified by the value of t11ZsServerFabricIndex)
> >            on a particular switch (identified by values of
> >            fcmInstanceIndex and fcmSwitchIndex).
> > 
> >            A Zone Set is created containing zero or more
> >            existing Zones.  As and when new Zones are created
> >            (as rows in the t11ZsZoneTable), they can be added
> >            to a Zone Set by creating an entry for each in the
> >            t11ZsSetZoneTable.
> > 
> >            The StorageType of a row in this table is specified by
> >            the instance of t11ZsServerDatabaseStorageType which is
> >            INDEX-ed by the same values of fcmInstanceIndex,
> >            fcmSwitchIndex and t11ZsServerFabricIndex."
> >         INDEX   { fcmInstanceIndex, fcmSwitchIndex,
> >                   t11ZsServerFabricIndex, t11ZsSetIndex }
> >         ::= { t11ZsSetTable 1 }
> > 
> >   So it seems to me I can do SNMP SET to create an entry in this
> >   table. But is is not clear if, when I do so, and entry in the 
> >   t11ZsServerTable must already exist or not. Probably so,
> >   because it uses the actual (index) objects from that table.
> >   But in practice, can an SNMP utility not just create entries
> >   with index values that do not really exists in the base
> >   table? I'd like to know how the agent is supposed to react.
>  
> Well, yes, the row in the t11ZsServerTable must exist, but to say
> "already exist" would mislead the reader because there's no RowStatus
> in that table.  Instead, there's an entry in the t11ZsServerTable
> for the Zone Server for a particular fabric on a particular switch.
> I think that's already implicit in:
> 
>            "Each entry contains information about a Zone Set
>            in the Zone Set database of a particular fabric
>            (identified by the value of t11ZsServerFabricIndex)
>            on a particular switch (identified by values of
>            fcmInstanceIndex and fcmSwitchIndex).
> 
> In other words, this MIB about creating/editing information in the
> Zone Set Database of existing Zone Servers, not for creating new
> Zone Servers on switches and/or new Fabrics.
> 
> Would it help to insert "existing" in the above paragraph to try to
> make it more explicit ??
> 

If you mean to change
            "Each entry contains information about a Zone Set
into
            "Each entry contains information about a existing Zone Set
then I think that would make it clearer (at least for me).
See, I sort of concluded that, but it is always nice (as a new implementer
of a spec that one did not co-develop/co-design) to get affirmation of what
you think needs to or can be done.

> >   So if the base table entrues must exist first,
> >   then it would be good to say so, i.e. spell it out.
> >   And to say what happens if it does not yet exist.
> >   If not, then I wonder how/when the entry in that t11ZsServerTable
> >   does get created, because otherwise it is unclear how/if/when
> >   the persistency works.
> >   
> >   And what when I delete the row? Does it have any effect on the
> >   associated rows in t11ZsServerTable. Possibly not. But I am
> >   not sure how I can determine that based on the current
> >   DESCRIPTION clauses.
>  
> Deleting a row from the t11ZsSetTable deletes the Zone Set from the
> Zone Set Database maintained by the Zone Server, but does not
> otherwise affect the Zone Server.
> 

I'd say that it might be good to add that to the t11ZsSetEntry 
DESCRIPTION clause.

> > - I have the same/similar question for t11ZsZoneEntry
>  
> So, shall I also insert "existing" into t11ZsZoneEntry's DESCRIPTION
> to try to make it similarly more explicit ??
> 
pls do so

> > - Can t11ZsZoneAttribBlock be changed while row is active?
> > 
> >   such questions can be asked for more read-write/read-create
> >   objects in this MIB module. I won't keep repeating.
>  
> See the picture in section 5.6 -- all read-write objects in the
> Zone Set Database can be modified at any time.  The reason that other
> MIBs don't allow writes while a row is active is because they overload
> the RowStatus for in-use/not-in-use as well as for create/delete.
> In this MIB, only the Active Zone Set is in-use and it is read-only
> except to be Activated/De-Activated.
> 
> I too don't want to keep repeating it.  So, suggest I add a paragraph
> to the MODULE-IDENTITY's DESCRIPTION explaining that the MIB is a
> combination of the Zone Set Database and the Active Zone Set, 
> where all
> objects representing the former are modifiable at any time whereas all
> objects representing the latter are always read-only, other than by
> completely overwritting the Active Zone Set by a subset of Zone
> Set Database, or by completely deleting it.
> 

That would be a good idea. Possibly adding a ptr to sect 5.6 in this 
document, so that when someone (in teh future) reads an exatrcted 
MIB, that they can find the info.

> > - For t11ZsSetZoneEntry, it seems that the 3 other tables MUST
> >   have an existing associated entry(entries) before creating 
> >   an entry in this row makes sense. But maybe it is OK to 
> >   prepare this table before the other tables have been 
> >   completed/created?
>  
> > - for t11ZsSetZoneRowStatus I wonder what happens if this
> >   one has a value of active, byt the rowstatus in some of
> >   the other (base) tables have a value of notInservice or
> >   notReady ??
> > 
> >   Are we all supposed to try and figure this out, or would it
> >   be better to put something about this in the various
> >   DESCRIPTION clauses?
> >
> > - In fact the whole fate-sharing between all the tables may
> >   need to be described. I see some of it in section 5.5. and
> >   5.6 of the document, but also from that I do not yet see
> >   what the implications are if the rowstatus in one table is
> >   notInservice, while others are actve or  maybe notReady,
> >   or maybe do not (yet) exist.
> >   I must also admit that I have not studied the T11 documents 
> >   much (in fact very little) yet. But I'd hope that these
> >   basic question would be answered in the IETF MIB document
> >   itself.
>  
> OK.
> 
thanks

> > - I see no persistency behaviour (or a link to the StorageType
> >   objects in the base table in t11ZsActivateTable.
> >   I think it is clear that the writable objects are all
> >   volatile (they seem to be control objects that cause an
> >   action when SET).
>  
> Persistency is fully specified in those objects which include
> this statement: 
> 
>            When read, the value of this object is always xxx.
> 
> This statement:
> 
>            "A textual message indicating the reason for the
>            most recent failure of a Zone Set activation or
>            de-activation, or the zero-length string if no
>            information is available.
> 
> allows an agent to retain the info for as long as it can.
> 
> I'll modify:
> 
>            The value 'none' indicates activation/de-activation
>            has not been attempted.
> 
> by appending "since the last restart of the management system."
> 

Thanks.
I'd have to go reread the whole MIB again if that addresses my
complete comment on persistency.

> > - For namingconsistency in:
> >     T11ZsActiveZoneEntry ::= SEQUENCE {
> >        t11ZsActiveZoneIndex      Unsigned32,
> >        t11ZsActiveZoneName       T11ZoningName,
> >        t11ZsActiveBroadcast      TruthValue,
> >        t11ZsActiveHardZoning     TruthValue
> >     }
> >   I would insert a "Zone" before "Broadcast" and before "Hardzoning"
>  
> I didn't do that because whereas t11ZsActiveZoneIndex is the Zone's
> Index and t11ZsActiveZoneName is the Zone's Name, t11ZsActiveBroadcast
> is not the Zone's Broadcast.  Further, t11ZsActiveBroadcast is about
> "Broadcast Zoning", not "Zone Broadcast" -- t11ZsActiveZoneBroadcast
> gives the wrong impression.  So, I guess it has to be
> t11ZsActiveZoneBroadcastZoning.
> 

That would then probably be better (but also longer, which I know you hate. 
I can live with names up to 64 characters these days).

Note that I am just pointing out where I perceive inconsistencies.
I appreciate your explanation as to why it exists here.
It is all within this t11ZsXxxx namespace, so it is not as dramatic
that I absolutely must see it changed. I would like that, but I understand
it is somewhat personal taste or personal strictness on naming.

> >   By the way, t11ZsActiveZoneSetName in the T11ZsActiveEntry might
> >   be (at first sight) perceived to be in the T11ZsActiveZoneEntry.
> >   I understand why it has that name, but it may consfuse some
> >   people.
> > 
> > - t11ZsActiveBroadcast and t11ZsActiveHardZoning both have in
> >   their DESCRIPTION clauses:
> >              This object is only instantiated in Enhanced mode."
> > 
> >   would we not want to specify that in a MODULE-COMPLIANCE for 
> >   basic mode and one for enhanced mode?
>  
> They are both in the t11ZsEnhancedModeGroup, and it is specified as:
> 
>     GROUP        t11ZsEnhancedModeGroup
>     DESCRIPTION
>            "This group is mandatory only for those systems
>            with Zone Servers which support Enhanced Mode."
> 
> which I believe is sufficient.
>  

I see (now that you point it out). 
Some (I may be one of them) like to not see "compliance/optional/required"
in DESCRIPTION clauses of objects, but ratehr see them in the MODULE-COMPLIANCE.
If they are in both places (and consistent) I can live with it.

> > --------- NITS/TYPOs
> > 
> > - In one but last para of DESCRIPTION clause of MODULE-IDENTITY
> > 
> >      When this MIB is used for Basic Zoning Management, the same
> >      set of MIBs objects as used for Enhanced mode are used to
> > 
> >   s/MIBs objects/MIB objects/
> > 
> > - In t11ZsServerFabricIndex, the last 2 paragraphs of the
> >   DESCRIPTION clause seem redundant with the DESCRIPTION clause
> >   of the TC itself. I would remove them. The idea of a TC is
> >   to have one place (namely in the DESCRIPTION clause of the TC)
> >   to describe the (basic) semantics of the objects that use 
> >   the TC as a SYNTAX.
>  
> If I recall correctly, I added them there due to some earlier
> comment on an exactly-equivalent definition (I don't remember which
> MIB it was in).
> 

Was that commen from me (meaning I would be inconsistent in my commenting)?
I am not saying that this is impossible, but in general I believe I do 
comment that we prefer to not to see a lot of stuff from the DESCRIPTION
clause of a TC repeated in teh DESCRIPTION clause of an object that
uses teh TC for its SYNTAX.

Not that this was under "NITS", so I am not too upset about it.

> > - t11ZsServerCapabilityObject
> >   I think I would rename zonesetDb(1) to zoneSetDb(1)
> >   but this is pretty subjective taste of course.
> > 
> > - last para of description clasue of t11ZsServerDatabaseStorageType
> > 
> >            This value of this object is a...
> > 
> >   s/This/The/ ??
> >   
> > - For t11ZsAttribType maybe add "other values reserved" in the 
> >   DESCRIPTION clause. I went looking it up, because in an 
> >   earlier object we had E0-EF as Vendor specific. So I thought
> >   that might also be the case here. But the text in the 
> >   REFERENCEd docment/section told me they are reserved.
>  
> Values which are reserved today could easily be allocated tomorrow.
> Values which are allocated today will likely stay allocated to the
> same thing for a long time into the future.  Thus, listing 
> the allocated
> values and omitting the reserved values has the best chance of
> continuing to be correct in the future.
> 

OK, but that is then inconsistent with the earlier object, and so that
is also why I got confused.

But again, it is a NIT, so I leave it up to you.

> > - for
> >    t11ZsActivateRequest OBJECT-TYPE
> >      SYNTAX       Unsigned32 (0..4294967295)
> >      MAX-ACCESS   read-write
> >      STATUS       current
> >      DESCRIPTION
> >            "Setting this object to a value is a request for a
> >            Zone Set to be activated on the fabric which is
> >            represented by this row.  The Zone Set to be
> >            activated is the one for which t11ZsSetIndex has
> >            the same value.
> > 
> >            If a Zone Set is already active on a fabric when a
> >            request is made to activate a different one on that
> >            fabric, then the existing Zone Set is automatically
> >            deactivated and the specified Zone Set is activated
> >            in its place.
> > 
> >            The value of this object when read is always 0."
> > 
> >    It seems that setting the value to zero has no effect. Right?
> >    But zero seems to also have special meaning. Oh well. I might
> >    indicate it by using 
> >      SYNTAX       Unsigned32 (0 | 1..4294967295)
> >    but that is subjective taste I guess.
> >
> > - similarly, for
> > 
> >     t11ZsFabricIndex OBJECT-TYPE
> >         SYNTAX       Unsigned32 (0..4096)
> > 
> >   I think I would use  
> > 
> >         SYNTAX       Unsigned32 (0..4095 | 4096)
> > 
> >   to indicate that 4096 has special meaning.
>  
> The example which is most well-known (at least to me) of a "special
> meaning" is InterfaceIndexOrZero which is not indicated like this.

Yep... defined along long time ago.
My suggested notation is used more and more.

> Further, I don't know where, if anywhere, your convention is
> documented, and I think you would have difficulty defining the
> term "special meaning" if you did try to document it.
> 

Forget my rambling if you rather not do it.
Not worth the time if we disagree.

> >   Maybe I would even create a 
> > 
> >       T11FabricIndexOrAll ::= TEXTUAL-CONVENTION
> > 
> >   So it could if an "ALL" option is needed in the future that it is
> >   (or at least can be) done in a consistent maner.
>  
> If I thought that it would be re-used, then yes, I'd do this.
> But, after so many (that I've lost count) Fibre Channel MIBs, and
> now that I'm working on the last set (at least, the last scheduled
> ones), I don't think it's worth it.
> 

OK... your call.

> > - I personally prefer to name notifications xxxNotification instead
> >   of naming them xxxNotify. But I admit that that is subjective.
> > 
> > Bert
> > 
> 

Bert

_______________________________________________
imss mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/imss